package ru.landgrafhomyak.serdha.api.v0.ddl

import ru.landgrafhomyak.serdha.api.v0.runtime.Transaction

public interface ModuleTemplate<ModuleUserExtension : Any> {
	public interface Provider<UserExtension : Any> {
		public fun createModuleTemplates(creator: Creator): UserExtension
	}

	public interface Creator {
		public fun <NewModuleUserExtension : Any> createTemplate(
			versionKey: String,
			updater: CreateModule<NewModuleUserExtension>,
		): ModuleTemplate<NewModuleUserExtension>

		public fun <OldModuleUserExtension : Any, NewModuleUserExtension : Any> upgradeTemplate(
			versionKey: String,
			updater: UpgradeModule<OldModuleUserExtension, NewModuleUserExtension>,
		): ModuleTemplate<NewModuleUserExtension>
	}

	public interface CreateModule<ModuleUserExtension : Any> {
		public fun createSchema(rootNs: Namespace, creator: ModuleCreator): ModuleUserExtension

		public suspend fun initData(ext: ModuleUserExtension, transaction: Transaction) {}
	}

	public interface UpgradeModule<OldModuleUserExtension : Any, NewModuleUserExtension : Any> {
		public fun upgradeSchema(oldModule: Module<OldModuleUserExtension>, rootNs: Namespace, updater: ModuleCreator): NewModuleUserExtension

		public suspend fun upgradeData(ext: NewModuleUserExtension, transaction: Transaction) {}

		public fun postUpgradeCleanupSchema(ext: NewModuleUserExtension, updater: ModuleCreator) {}
	}

	public val versionKey: String
}