package ru.landgrafhomyak.serdha.api.v0.ddl

import ru.landgrafhomyak.serdha.api.v0.Expression

public interface TableCreator<TableUserExtension : Any> {
	public val expressionBuilder: Expression.Builder<TableUserExtension>

	public val types: ColumnType.Builder

	public fun <RuntimeType, DatabaseType : ColumnType<RuntimeType>> column(name: String, type: DatabaseType): Column<RuntimeType, DatabaseType, TableUserExtension>

	public fun index(name: String, vararg columns: Column<*, *, TableUserExtension>): Index<TableUserExtension>

	public fun uniqueIndex(name: String, distinctNulls: Boolean, vararg columns: Column<*, *, TableUserExtension>): UniqueIndex<TableUserExtension>
	public fun checkConstraint(name: String, constraint: Expression<Boolean, ColumnType.BOOLEAN, TableUserExtension>): CheckConstraint<TableUserExtension>
	public fun <RuntimeType : Any, DatabaseType : ColumnType<RuntimeType>> defaultValue(c: Column<RuntimeType, DatabaseType, TableUserExtension>, expr: Expression<RuntimeType, DatabaseType, TableUserExtension>): DefaultConstraint<RuntimeType, DatabaseType, TableUserExtension>

	@Suppress("PropertyName")
	public val rowId_column: Column<RowId<TableUserExtension>, ColumnType<RowId<TableUserExtension>>, TableUserExtension>

	@Suppress("PropertyName")
	public val rowId_uniqueConstraint: UniqueIndex<TableUserExtension>

	public fun <TargetTableUserWrapper : Any> selfRowReference(
		onDelete: ForeignRowReference.OnDeleteAction,
		toColumn: Column<RowId<TargetTableUserWrapper>, ColumnType.ROW_ID<TargetTableUserWrapper>, TargetTableUserWrapper>,
	): ForeignRowReference<TableUserExtension, TableUserExtension>

	public fun <TargetTableUserWrapper : Any> foreignRowReference(
		fromColumn: Column<RowId<TargetTableUserWrapper>, ColumnType.ROW_ID<TargetTableUserWrapper>, TableUserExtension>,
		toTable: Table<TargetTableUserWrapper, *>,
		toColumn: Column<RowId<TargetTableUserWrapper>, ColumnType.ROW_ID<TargetTableUserWrapper>, TargetTableUserWrapper>,
		onDelete: ForeignRowReference.OnDeleteAction,
	): ForeignRowReference<TableUserExtension, TargetTableUserWrapper>
}